module Logger where

import Core

import Effectful
import Effectful.Dispatch.Dynamic
import Effectful.Error.Static             (Error, throwError)
import Effectful.FileSystem
import Effectful.Reader.Static
import GHC.Generics                       (Generic)
import Servant                     hiding ((:>))

type instance DispatchOf Logger = 'Dynamic

writeLog :: (Logger :> es, Error ServerError :> es) => String -> Eff es ()
writeLog = send . WriteLog

runLoggerIO :: (IOE :> es, Error ServerError :> es) =>
  Eff (Logger : es) a -> Eff es a
runLoggerIO = interpret $ \_ -> \case
  WriteLog msg -> log msg
  where
    log :: (IOE :> es, Error ServerError :> es) => String -> Eff es ()
    log msg = liftIOE $ putStrLn msg
