module Routes where

import Core
  
import qualified Data.Text as T
import Servant

--
-- Routes
--
type Root = Get '[PlainText] T.Text

type UserList = "user"
  :> Get '[JSON] [User]

type UserGet = "user"
  :> Capture "userId" Int
  :> Get '[JSON] User

type UserPost = "user"
  :> ReqBody '[PlainText] String
  :> PostCreated '[PlainText] NoContent

type AppAPI = Root
  :<|> UserList
  :<|> UserGet
  :<|> UserPost
